
import * as FS from 'fs';
import Terser from 'terser';


function fileReplace(file, filePath) {
    let folder = filePath.split('/').slice(0,-1).join('/');
    console.log(folder);
    let regex = /FILE:(.*):FILE/g;
    let matches = file.match(regex);
    if (matches)
        for (let match of matches)
            // console.log(match.slice(6, -6));
            file = file.replace(match, '`'+FS.readFileSync(folder+'/'+match.slice(6, -6), 'utf8')+'`');
    // return file.replace(regex,'');
    console.log(matches);
    return file;
}

function web(file) {
    file = file.replace(/\/\/<<NODE.*?\/\/NODE>>/gms, ''); //gms in es2018  replace .* with [/s/S]* before that
    file = file.split('\n').filter(line => !line.includes('//NODE')).join('\n');
    // file = Terser.minify(file).code;
    return file;
}

function node(file) {
    file = file.replace(/\/\/<<WEB.*?\/\/WEB>>/gms, ''); //gms in es2018  replace .* with [/s/S]* before that
    file = file.split('\n')
        .filter(line => !line.includes('//WEB') && !line.includes('//<<NODE') && !line.includes('//NODE>>'))
        .join('\n');
    file = file.replace(/\/\/NODE/g, '');
    return file;
}

export function build(filePath, targetFolder) {
    let source = FS.readFileSync(filePath, 'utf-8');
    source = fileReplace(source, filePath);
    FS.writeFileSync(targetFolder + '/web.js', web(source));
    FS.writeFileSync(targetFolder + '/node.js', node(source));
    FS.writeFileSync(targetFolder + '/web.min.js', Terser.minify(web(source), { mangle: { toplevel: true } }).code);
}

